%global gem_name rdiscount
Name:           rubygem-rdiscount
Version:        2.2.0.2
Release:        2
Summary:        Converts documents in Markdown syntax to HTML
License:        ASL 1.1
URL:            http://github.com/rtomayko/rdiscount
Source0:        http://rubygems.org/gems/rdiscount-%{version}.gem
# The patch used to modify test failed
Patch0:         rdiscount_test.rb.patch
BuildRequires:  rubygems-devel ruby-devel libmarkdown-devel rubygem(test-unit) gcc

%description
The package converts documents in Markdown syntax to HTML.
It uses the excellent Discount processor by David Loren Parsons for this purpose.

%package        help
Summary:        Documentation for rubygem-rdiscount
BuildArch:      noarch
Requires:       rubygem-rdiscount = %{version}-%{release}
Provides:       rubygem-rdiscount-doc = %{version}-%{release}
Obsoletes:      rubygem-rdiscount-doc < %{version}-%{release}

%description    help
This package contains documentation for rubygem-rdiscount.


%prep
gem unpack %{SOURCE0}
%setup -q -D -T -n  %{gem_name}-%{version}
%patch0 -p0
gem spec %{SOURCE0} -l --ruby | sed -e 's|,|,\n|g' > %{gem_name}.gemspec

(cd ext; ls -1 *.c *.h | grep -v rdiscount.c ) > discount_files

cat discount_files | while read f ; do
	rm -f ext/$f
	sed -i %{gem_name}.gemspec -e "\@ext/$f@d"
done

sed -i ext/extconf.rb \
	-e '\@create_makefile@i \$libs = "-lmarkdown"' \
	%{nil}

%build
rm -rf ./%{gem_extdir_mri}
rm -rf ./%{gem_instdir}
gem build %{gem_name}.gemspec

%gem_install

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{gem_dir}
mkdir -p %{buildroot}%{_mandir}/man1
mkdir -p %{buildroot}%{_mandir}/man7
mv .%{gem_instdir}/man/rdiscount.1 %{buildroot}%{_mandir}/man1
mv .%{gem_instdir}/man/markdown.7 %{buildroot}%{_mandir}/man7
cp -a .%{gem_dir}/*  %{buildroot}%{gem_dir}

rm -rf %{buildroot}%{gem_instdir}/ext
mkdir -p %{buildroot}%{gem_extdir_mri}
cp -a .%{gem_extdir_mri}/{gem.build_complete,*.so} %{buildroot}%{gem_extdir_mri}/

mkdir -p %{buildroot}/%{_bindir}
mv .%{_bindir}/* %{buildroot}/%{_bindir}

%check
pushd .%{gem_instdir}
ruby -Ilib:%{buildroot}%{gem_extdir_mri}:. \
	-e 'gem "test-unit" ; Dir.glob("test/*_test.rb").sort.each {|f| require f}'

popd

%files
%{_bindir}/rdiscount
%dir %{gem_instdir}
%{gem_instdir}/bin/
%{gem_libdir}/
%doc %{gem_instdir}/BUILDING
%doc %{gem_instdir}/COPYING
%doc %{gem_instdir}/README.markdown
%exclude %{gem_cache}
%{gem_spec}
%{gem_extdir_mri}/
%{_mandir}/man1/rdiscount.1.gz
%exclude %{_mandir}/man7/markdown.7.gz

%files help
%doc %{gem_instdir}/Rakefile
%{gem_docdir}
%{gem_instdir}/man
%{gem_instdir}/test
%{gem_instdir}/rdiscount.gemspec


%changelog
* Fri Aug 11 2023 wubijie <wubijie@kylinos.cn> - 2.2.0.2-2
- Use %gem_extdir_mri instead of ext for %check due to ruby3.2 change

* Tue Jun 28 2022 wulei <wulei80@h-partners.com> - 2.2.0.2-1
- Upgrade to 2.2.0.2

* Mon Jun 28 2021 wulei <wulei80@huawei.com> - 2.2.0.1-5
- fix missing gcc

* Sat Mar 14 2020 zhujunhao <zhujunhao5@huawei.com> - 2.2.0.1-4
- Package init